
package ParaIrc.client;

import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;

import javax.swing.JFrame;


public class ParaIrc {

	static ParaIrcLoader loader;
	private static ParaIrcGui gui; 
	protected static String AppTitle="ParaIrc 0.2.2";
	

	//Config
	private static ParaIrcConfig Config;
	private static ParaIrcConfig ColorConfig;

	public static Image getParaIrcIcon (JFrame window)
	{
		// load Icon
		Toolkit tk = window.getToolkit();
		Image Iconimage = tk.createImage(ParaIrc.class.getResource( "/ParaIrc/Resources/Icon.png" ));
		   while ( !tk.prepareImage( Iconimage, -1, -1, window ) ) {
			 try {
			   Thread.sleep( 100 );
			 } catch ( Exception e ) {}
		   }

		return Iconimage;
	}

	public static void main(String[] args) 
	{
	
		//load Colors
	
		Config=new ParaIrcConfig(ParaIrc.class.getResourceAsStream( "/ParaIrc/Resources/ParaIrc.config" ));
		ColorConfig=new ParaIrcConfig(ParaIrc.class.getResourceAsStream( "/ParaIrc/Resources/ParaIrc.colors" ));
		
		File configFile=new File("ParaIrc.config");
		if (configFile.exists())
		{
			Config.loadConfigFromFile("ParaIrc.config");
		}
		gui=new ParaIrcGui();

		// load GUI und IrcLib Interface
		gui.setVisible(true);	
		loader = new ParaIrcLoader(gui);
	}
	
	static ParaIrcGui getGui()
	{
		return gui;
	}
	
	static ParaIrcLoader getLoader()
	{
		return loader;
	}
		
	public static Color getColor(String text)
	{
		text=ColorConfig.getConfig(text);
		if (text==""){text="0,0,0";} // If Color not in File, return BLACK
		int r=Integer.parseInt(text.substring(0,text.indexOf(",")));
		text=text.substring(text.indexOf(",")+1);
		int g=Integer.parseInt(text.substring(0,text.indexOf(",")));
		text=text.substring(text.indexOf(",")+1);
		int b=Integer.parseInt(text);
		return new Color(r,g,b);
	}
	
	
	public static String getConfig(String confname)
		{
			return Config.getConfig(confname);
		}
	
	public static int getConfigInt(String confname)
	{
		return Config.getConfigInt(confname);
	}
	
	public static void setConfig(String confname,String confvalue)
	{
		Config.setConfig(confname,confvalue);
	}
	
	public static void quitParaIrc()
	{
		gui.savePosition();
		gui.getOptionsDlg().saveSize();
		loader.ircLib.shutdown();
		Config.saveConfigToFile("ParaIrc.config");
		System.exit(0);
	}

	public static boolean getConfigBool(String string) {
		return (getConfigInt(string)==1);
	}
}
