/*
 * Created on 18.01.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Martin Spler
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ParaIrc.client;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.PopupMenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;

public class ParaIrcChannels
{
	
	private int maxchannels;
	private ParaIrcChannel[] channels;
	private ParaIrcUserChat[] userWindows;
	private int channelCount=0;
	private int maxUserWindows=5;
	private ParaIrcGui gui;
	private JTabbedPane tab;
	private String[] channelSave;
	
	public ParaIrcChannels(ParaIrcGui ircgui,int count)
	{
		this.maxchannels=count;
		this.channels = new ParaIrcChannel[maxchannels];
		this.userWindows= new ParaIrcUserChat[maxUserWindows];
		this.gui=ircgui;
	}
	
	public void rejoinAll()
	{
		if (channelSave!=null)
		{
			for (int i=0;i<channelSave.length;i++)
			{
				ParaIrc.loader.processMessage("/join "+channelSave[i],"");
			}
		}
		channelSave=null;
		
	}
	
	public void sendToChannel(String channel,String message,Color c)
	{
	    sendToChannel(channel, message, c, false);
	}
	
	public ParaIrcChannel getChannel(String channelName)
	{
		channelName=channelName.toLowerCase();
		for (int i=0;i<channelCount;i++)
		{
			if (channels[i].getChannel().equals(channelName.trim()))
			{
				return channels[i];
			}
		}
		System.err.println("Channel "+channelName+" not found");
		return null;
	}
	

	public void removeChannel(String channel)
	{
		for (int i=0;i<channelCount;i++)
		{
			if(channels[i].getChannel().equals(channel))
			{
				int j=i;
				gui.getTab().remove(channels[i]);
				for (j=i;j<channelCount-1;j++)
				{
					channels[j]=channels[j+1];
				}
				channels[j]=null;
				channelCount--;
				break;
			}
		}
	}
	
	public void newChannel(String channel)
	{	
		if (channel.indexOf("#")==0 )
		{
			channels[channelCount]= new ParaIrcChannel(gui,channel);
			gui.getTab().add(channels[channelCount]);
			gui.getTab().setSelectedIndex(gui.getTab().indexOfComponent(channels[channelCount]));
			channelCount++;
		}
	}
	
	public void userChangedNick (String user, String newNick)
	{
		for (int i=0; i<channelCount;i++)
		{
			if (channels[i].hasUser(user))
			{
				channels[i].renameUser(user,newNick);
				channels[i].sendText(user+" changed Nick to "+newNick,ParaIrc.getColor("Nickchange"));		
			}
		}
	}
	

	public void userQuit(String user, String message)
	{
		for (int i=0; i<channelCount;i++)
		{
			if (channels[i].hasUser(user))
			{
				channels[i].removeUser(user);
				channels[i].sendText(user+" has Quit:"+message,ParaIrc.getColor("Quit"));		
			}
		}
	}

	/**
	 * leave all Channels, but save them for rejoin
	 */
	public void leaveAllChannels() {
		int tmpchannelLength=0;
		if (channelSave!=null)
		{
			tmpchannelLength=channelSave.length;
		}
		String[] tmpchannelSave= new String[channelCount+tmpchannelLength];
		for (int i=0;i<tmpchannelLength;i++)
		{
			tmpchannelSave[i]=channelSave[i];
		}
		
		int tempChannelCount=channelCount;
		for (int i=0;i<tempChannelCount;i++)
		{
			tmpchannelSave[i+tmpchannelLength]=channels[0].getChannel().toString();
			channels[0].leave();			
		}
		this.channelSave=tmpchannelSave;
	}

	/**
	 * @param user
	 * @param message
	 */
	public void messageFromUser(String user, String message) {
		if (ParaIrc.getConfigBool("displayMCServInStatus") && ( user.toLowerCase().equals("memoserv") || user.toLowerCase().equals("nickserv")))
		{
			gui.getStatusField().printMessage("<"+user+"> "+message,ParaIrc.getColor("MCServInStatus"));
			return;
		}
		int nextpos=0;
		//looks for window in Array
		while (userWindows[nextpos]!=null&&!userWindows[nextpos].toString().equals(user))
		{
			nextpos++;
			if (nextpos==maxUserWindows)
			{ 
				break;
			}
		}
		if( userWindows[nextpos]!=null && userWindows[nextpos].toString().equals(user))
		{
			// if FOUND
			userWindows[nextpos].sendText(message,Color.BLACK);
			return;
		}
		
		nextpos=0;
		while (userWindows[nextpos]!=null && nextpos!=maxUserWindows)
		{
			nextpos++;
		}
		if (nextpos==maxUserWindows)
		{
			ParaIrcUserChat[] tempArray= new ParaIrcUserChat[2*maxUserWindows];
			for (int i=0;i<maxUserWindows;i++)
			{
				tempArray[i]=userWindows[i];
			}
			userWindows=tempArray;
			maxUserWindows=maxUserWindows*2;
		}
		else
		{ // else create new Window
			userWindows[nextpos]=new ParaIrcUserChat(gui,user);
			gui.getTab().add(userWindows[nextpos],user);
			userWindows[nextpos].sendText(message,Color.BLACK);
		}
		
	}

	/**
	 * @param userchat
	 */
	public void removeUserChat(ParaIrcUserChat chat) {
		for (int i=0;i<userWindows.length;i++)
		{
			if (userWindows[i]==chat)
			{
				userWindows[i]=null;
				return;
			}
		}
	}

    /**
     * @param channel
     * @param Message
     * @param Color
     * @param print it bold
     */
    public void sendToChannel(String channel, String message, Color c, boolean bold) {
		channel=channel.trim().toLowerCase();
		for (int i=0;i<channelCount;i++)
		{
			if (channels[i].getChannel().equals(channel))
			{
				channels[i].sendText(message,c, bold);
				return;
			}
		}
		
	// if no fitting channel exists, create a new one
	newChannel(channel);
	channels[channelCount-1].sendText(message,Color.BLACK,bold);
        
    }
	
}

class ParaIrcChannelStatusBar extends JComponent implements ActionListener{
	
	private JLabel channelStatus;
	private final ParaIrcChannel channel;
	
	public ParaIrcChannelStatusBar(ParaIrcChannel channel)
	{
		this.channel=channel;
		this.setLayout(new BorderLayout(1,2));
		this.setVisible(true);
		
		channelStatus= new JLabel(" ");
		add(channelStatus,BorderLayout.CENTER);
		JButton leaveChannel = new JButton("X");
		leaveChannel.setBorderPainted(true);
		leaveChannel.addActionListener(this);
		add(leaveChannel,BorderLayout.EAST);
	}
	
	public void setText(String text)
	{
		channelStatus.setText(text);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent arg0) {
		channel.leave();		
	}

}class ParaIrcUserStatusBar extends JComponent implements ActionListener{
	
	private JLabel channelStatus;
	private final ParaIrcUserChat chat;
	
	public ParaIrcUserStatusBar(ParaIrcUserChat chat)
	{
		this.chat=chat;
		this.setLayout(new BorderLayout(1,2));
		this.setVisible(true);
		
		channelStatus= new JLabel(" ");
		add(channelStatus,BorderLayout.CENTER);
		JButton leaveChannel = new JButton("X");
		leaveChannel.setBorderPainted(true);
		leaveChannel.addActionListener(this);
		add(leaveChannel,BorderLayout.EAST);
	}
	
	public void setText(String text)
	{
		channelStatus.setText(text);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent arg0) {
		chat.quit();		
	}

}

class ParaIrcUserListPopupClick implements ActionListener
{
	JList userList;
	
	public ParaIrcUserListPopupClick(JList userList)
	{
		this.userList=userList;
	}
	public void actionPerformed(ActionEvent arg0) {
		String user =userList.getModel().getElementAt(userList.getSelectedIndex()).toString();
		if (user.indexOf("@")>-1 || user.indexOf("+")>-1)
		{
			user=user.substring(1);
		}
		if (arg0.getActionCommand()=="send PrivMSG")
		{
			ParaIrc.getGui().getChannels().messageFromUser(user,"");
			ParaIrc.getGui().getTab().setSelectedIndex(ParaIrc.getGui().getTab().indexOfTab(user));
		}
		else if (arg0.getActionCommand()=="Version")
		{
			ParaIrc.getLoader().ircLib.processMessage("/version "+user,"");
		}
		else if (arg0.getActionCommand()=="Ping")
		{
			ParaIrc.getLoader().ircLib.processMessage("/ping "+user,"");
		}
		else if (arg0.getActionCommand()=="Time")
		{
			ParaIrc.getLoader().ircLib.processMessage("/time "+user,"");
		}
		else if (arg0.getActionCommand()=="Whois")
		{
			ParaIrc.getLoader().ircLib.processMessage("/whois "+user,"");
		}
	}
	
}
class ParaIrcUserListPopup extends MouseAdapter
{
	PopupMenu m_pmnPopup;
    
	public ParaIrcUserListPopup(JList userList, PopupMenu popup) {
			m_pmnPopup = popup;
		}
    
		public void mousePressed(MouseEvent e) {
			//maybeShowPopup(e);
		}

		public void mouseReleased(MouseEvent e) {
			maybeShowPopup(e);
		}

		void maybeShowPopup(MouseEvent e) {
			if (e.getButton()==1 && e.getClickCount()==2) {
				m_pmnPopup.show((Component)e.getSource(),
				e.getX(),e.getY());
				//m_pmnPopup.requestFocus();
			}
		}

}

class ParaIrcUserChat extends JComponent{

	private JTextField sendtext;
	private ParaIrcGuiColorPane textfield;
	private Button send;
	private String userName;
	private ParaIrcGui ircGUI;
	private ParaIrcUserStatusBar chatStatus;
	private boolean useGUI=false;
	private PopupMenu popup;
	
	public ParaIrcUserChat(ParaIrcGui gui,final String userName)
	{
		useGUI=true;
		ircGUI=gui;		
		this.userName=userName;
		ActionListener sendclick = new ActionListener()
		{
			public void actionPerformed( ActionEvent e )
			{
				if (sendtext.getText().indexOf("/")==0)
				{
					ParaIrc.getLoader().getIrcLib().processMessage(sendtext.getText(),"");
										
				}
				else
				{				
					ParaIrc.getLoader().getIrcLib().processMessage( "/msg "+userName+" "+sendtext.getText(),""); 
				} 
				display("<"+ParaIrc.getLoader().getIrcLib().getNick()+"> "+sendtext.getText());
				sendtext.setText("");
			}
		};
			this.setLayout(new BorderLayout(1,2));
		chatStatus = new ParaIrcUserStatusBar(this);
		add(chatStatus, BorderLayout.NORTH);
		textfield =new ParaIrcGuiColorPane();
		sendtext = new JTextField("",25);
		popup= new PopupMenu();
		popup.add("Version");
		popup.add("Ping");
		popup.add("Time");
		popup.add("Whois");
		// TODO: probably add Popup Window !!
		sendtext.addActionListener(sendclick);
		JScrollPane textScrollPane = new JScrollPane(textfield);
		add(textScrollPane, BorderLayout.CENTER);
		textfield.setScrollBar(textScrollPane);
		add(sendtext, BorderLayout.SOUTH);
		this.setVisible(true);
	}
	
	public void quit()
	{
		ircGUI.getChannels().removeUserChat(this);
		ircGUI.getTab().remove(this);
		ircGUI.getTab().getChangeListeners()[0].stateChanged(null);
	}
	
	public void display (String text)
	{
		textfield.append(Color.BLACK,text+"\n");
	}
	
	public void sendText(String message, Color c)
	{
		if (message=="") {return;}
		textfield.append(c,"<"+this.userName+"> "+message+"\n");
		JTabbedPane tab = ircGUI.getTab();
		
		if (textfield!=null)
		{
			int currentPos = tab.indexOfTab(this.userName);
			if ( tab.getSelectedIndex()!= currentPos && currentPos>-1)
			{
				if ( ParaIrc.getConfigBool("displayImage") && tab.getIconAt(currentPos)==null)
				{
					tab.setIconAt( currentPos,ParaIrcGui.CHANGEICON);
				}
				if (ParaIrc.getConfigBool("changeColorOnChange") && tab.getTitleAt(currentPos)!=null && !tab.getTitleAt(currentPos).startsWith("<html><font color="+ParaIrc.getConfig("newMsgColorinHTML")+">"))
				{
					tab.setTitleAt(currentPos,("<html><font color="+ParaIrc.getConfig("newMsgColorinHTML")+">"+tab.getTitleAt(currentPos)));
				}			
			}
		}
		
	}
	
	public String toString()
	{
		return userName;	
	}
		
}

class ParaIrcChannel extends JComponent{

	private String topicInfo="";
	private JTextField sendtext;
	private ParaIrcGuiColorPane textfield;
	private Button send;
	private ParaIrcGui ircGUI;
	private String topic="";
	private String channel; 
	private ParaIrcChannelStatusBar channelStatus;
	private JList userList;
	private boolean useGUI=false;
	private PopupMenu popup;
	private ParaIrcUserList users = new ParaIrcUserList(this);
	
	public ParaIrcChannel(ParaIrcGui gui,String channelname)
	{
		channelname=channelname.toLowerCase();
		useGUI=true;
		ircGUI=gui;		
		this.channel=channelname;
		ActionListener sendclick = new ActionListener()
		{
			public void actionPerformed( ActionEvent e )
			{
				ParaIrc.getLoader().getIrcLib().processMessage( sendtext.getText(),channel);
				sendtext.setText("");
			}
		};
		this.setLayout(new BorderLayout(1,2));		
		textfield =new ParaIrcGuiColorPane();
		DefaultListModel userListModel = new DefaultListModel();
		userList = new JList(userListModel);
		sendtext = new JTextField("",25);
		popup= new PopupMenu();
		popup.add("send PrivMSG");
		popup.add("Version");
		popup.add("Ping");
		popup.add("Time");
		popup.add("Whois");
		popup.addActionListener(new ParaIrcUserListPopupClick(userList));
		add(popup);
		userList.addMouseListener(new ParaIrcUserListPopup(userList,popup));
		sendtext.addActionListener(sendclick);
		channelStatus = new ParaIrcChannelStatusBar(this);
		add(channelStatus,BorderLayout.NORTH);
		//channelStatus.show();
		JScrollPane textScrollPane = new JScrollPane(textfield);
		add(textScrollPane, BorderLayout.CENTER);
		textfield.setScrollBar(textScrollPane);
		add(sendtext, BorderLayout.SOUTH);
		userList.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		userList.setLayoutOrientation(JList.VERTICAL);
		userList.setVisibleRowCount(-1);
		JScrollPane listScroller = new JScrollPane(userList);
		listScroller.setPreferredSize(new Dimension(130, 80));
		add(listScroller, BorderLayout.EAST);
		users.setGuiList(userListModel);
		this.setVisible(true);
	}	
	
	/**
	 * 
	 */
	
	
	protected void leave() {
		ParaIrc.loader.ircLib.processMessage("/part "+channel,"");
		ircGUI.getChannels().removeChannel(channel);
		ircGUI.getTab().getChangeListeners()[0].stateChanged(null);
	}

	/**
	 * @param user
	 */
	public void renameUser(String user,String newNick) {
	
	users.changeUserName(user,newNick);
	}

	/**
	 * @param user
	 * @return
	 */
	public boolean hasUser(String user) {
		return users.hasUser(user);
	}


	private void updateTitle()
	{
		channelStatus.setText(" ("+users.getUserCount()+" Users) - "+topic);
	}
	
	public ParaIrcUserList getUserList()
	{
		return users;
	}
	
	public void setTopic(String text)
	{
		this.topic=text;
		if (this.topic.length()>0)
			sendText("#TOPIC#"+this.topic,ParaIrc.getColor("TopicText"));
		updateTitle();
	}
	
	public void setTopicInfo(String text)
	{
			this.topicInfo=text;
	}
	
	public void addUser(String userName)
	{
		users.addUser(new ParaIrcUser(userName));
		userList.validate();
		updateTitle();
	}
	
	public void display (String text)
	{
		textfield.append(Color.BLACK,text+"\n");
	}
	
	public void removeUser(String username)
	{
		users.removeUser(username);
		updateTitle();
	}
	
	public String getName()
	{
		return channel.toString();
	}
		
	public ParaIrcChannel (String channelname)
	{
		channelname=channelname.toLowerCase();
		this.channel=channelname;
	}
	
	
	public void sendText(String message, Color c)
	{
		sendText(message, c, false);
		
	}
	public void sendText(String message, Color c, boolean bold)
	{
		textfield.append(c,message+"\n",bold);
		/*if (ircGUI.getTab().getSelectedIndex()!=ircGUI.getTab().indexOfTab(this.channel))
		{
			if (ircGUI.getTab().getIconAt(ircGUI.getTab().indexOfTab(this.channel))==null)
			{
				ircGUI.getTab().setIconAt(ircGUI.getTab().indexOfTab(this.channel),ParaIrcGui.CHANGEICON);
			}
		}*/
		
		JTabbedPane tab = ircGUI.getTab();
		
		if (textfield!=null)
		{
			int currentPos = tab.indexOfTab(this.getName());
			if ( tab.getSelectedIndex()!= currentPos && currentPos>-1)
			{
				if ( ParaIrc.getConfigBool("displayImage") && tab.getIconAt(currentPos)==null)
				{
					tab.setIconAt( currentPos,ParaIrcGui.CHANGEICON);
				}
				if (ParaIrc.getConfigBool("changeColorOnChange") && tab.getTitleAt(currentPos)!=null && !tab.getTitleAt(currentPos).startsWith("<html><font color="+ParaIrc.getConfig("newMsgColorinHTML")+">"))
				{
					tab.setTitleAt(currentPos,("<html><font color="+ParaIrc.getConfig("newMsgColorinHTML")+">"+tab.getTitleAt(currentPos)));
				}			
			}
		}
		
	}
	
	public String toString()
	{
		return getChannel();	
	}
	
	public String getChannel()
	{
		return channel;
	}
		
}

class ParaIrcUser
{
	private String name;
	private String prefix="";
	
	public ParaIrcUser(String name)
	{
		if (name.indexOf("@")==0)
		{
			this.prefix="@";
			name=name.substring(1);
		}
		else if (name.indexOf("+")==0)
		{
			this.prefix="+";
			name=name.substring(1);
		}		
		this.name=name;
	}
	
	public String toString()
	{
		return getShownNick();
	}
	
	public String getNick()
	{
		return name;
	}
	
	public String getShownNick()
	{
		return (prefix.trim()+name);
	}

	/**
	 * @param newNick
	 */
	public void setNick(String newNick) {
		name=newNick;
		
	}

	/**
	 * @param Prefix ( @ or +)
	 */
	public void setPrefix(char c) {
		prefix=""+c;
		prefix.trim();				
	}
}

class ParaIrcUserList
{
	private ParaIrcChannel channel;
	private ArrayList users=new ArrayList();
	private DefaultListModel userList;
	
	//private String[] users=new String[10];
	
	public ParaIrcUserList(ParaIrcChannel channel)
	{
		this.channel=channel;
	}
	
	public void setGuiList(DefaultListModel userList) {
		this.userList=userList;
	}
	
	public int getUserCount()
	{
		return users.size();
	}
	
	public boolean hasUser(String user)
	{
		ParaIrcUser tempuser;
		for (int i=0;i<users.size();i++)
		{
			tempuser = (ParaIrcUser) users.get(i);
			if (tempuser.getNick().equals(user))
			{
			return true;
			}
		}
		return false;	
	}
	
	private void updateGuiListUser (String oldNick, String newNick)
	{
		
		if (oldNick!="")
		{	
			
			for (int i=0;i< userList.getSize();i++)
			{
				if (userList.getElementAt(i).equals(oldNick))
				{
					userList.remove(i);
					break;	
				}
			}
		}
		
		int start=0;
		int end=userList.getSize();
		int pos=0;
		
		
		if (userList.getSize()==0)
		{
			userList.addElement(newNick);
			return;
		}
		while (start!=end)
		{
			if ( (pos==0) || (pos==userList.getSize()) )
			{
				if (isLower(newNick,userList.getElementAt(0).toString())) //if nick is lower than first user
				{
					pos=-1;
					break;
				}
				if (!isLower(newNick,userList.getElementAt(userList.getSize()-1).toString())) //if nick is higher than last user
				{
					pos=userList.getSize();
					break;
				}
			}
			pos=(start+end)/2;
			if (isLower(newNick,userList.getElementAt(pos).toString())) //if nick is lower than checked user
			{
				if (end!=pos)
				{
					end=pos;
				}
				else
				{
					break;	
				}
			}
			else
			{
				if (start!=pos)
				{
					start=pos;
				}
				else
				{
					break;	
				}
			}
		}
		if (pos>=userList.getSize()-1)
		{
			userList.addElement(newNick);
		}
		else
		{	 
			userList.insertElementAt(newNick,pos+1); 
		} 
	}
	
	public void changeNickMode(char c, char mode, String nick)
	{
		ParaIrcUser tempuser = null;
		for (int i=0;i<users.size();i++)
		{
			tempuser = (ParaIrcUser) users.get(i);
			if (tempuser.getNick().equals(nick))
			{
				String oldnick=tempuser.getShownNick();
				if (c=='+')
				{
					if (mode=='v')
					{
						tempuser.setPrefix('+');
					}
					else if(mode=='o')
					{
						tempuser.setPrefix('@');			
					}
				}
				else
				{
					tempuser.setPrefix(' ');
				}
				//changeUserName(oldnick,nick); // to refresh GUI-User-List
				updateGuiListUser(oldnick,tempuser.getShownNick());
				return;
			}
		}
		
	}
	
	public void changeUserName(String user, String newNick)
	{
		ParaIrcUser tempuser;
		for (int i=0;i<users.size();i++)
		{
			tempuser = (ParaIrcUser) users.get(i);
			if (tempuser.getNick().equals(user))
			{
				String oldnick=tempuser.getShownNick();
				tempuser.setNick(newNick);
				updateGuiListUser(oldnick,tempuser.getShownNick());			
				return;
			}
		}
	}
	
	public void removeUser(String user)
	{
		ParaIrcUser tempuser;
		for (int i=0;i<users.size();i++)
		{
			tempuser = (ParaIrcUser) users.get(i);
			if (tempuser.getNick().equals(user))
			{
				users.remove(i);		
				if (userList.getElementAt(i).equals(user))
				{
					userList.remove(i);
				}
				else
				{
					String tempuser2="";
					for (int j=0;j<userList.getSize();j++)
						{
							tempuser2=userList.getElementAt(j).toString();
							if (tempuser2.indexOf("@")>-1 ||tempuser2.indexOf("+")>-1)
							{
								tempuser2=tempuser2.substring(1);
							}
							if (tempuser2.equals(user))
							{
								userList.remove(j);
							}
						}								
				}
				return;
			}	
		}
	}
	
	private boolean isLower(String mainUser,String lookUser)
	{
		boolean finish=false;
		boolean result=false;
		int pos=0;
		
		if (mainUser.charAt(pos)=='@')
		{
			if (lookUser.charAt(pos)=='@')
			{
				pos++;
			}
			else
			{
				return true;
			}
		}
		else if (lookUser.charAt(pos)=='@')
		{
			return false;
		}
		while(mainUser.length()>pos && lookUser.length()>pos )
		{
			
			int tempres=(byte)Character.toLowerCase(mainUser.charAt(pos))- (byte)Character.toLowerCase(lookUser.charAt(pos));
			if (tempres<0)
			{
				return true;
			}
			else
			{
				if (tempres==0)
				{
					pos++;
				}
				else
				{
				return false;
				}				
			}
		}
		
		return false;
		
	}
	
	public void addUser(ParaIrcUser user)
	{
		/*for (int i=0;i<users.size();i++)
		{
			ParaIrcUser tempuser=(ParaIrcUser) users.get(i);
			if (isLower(user.getShownNick(),tempuser.getShownNick()))
			{
				users.add(i,user);		
				userList.add(user.getShownNick(),i);
				return;
			}	
		}*/
		
		if (userList.getSize()!=-1)
		{
			updateGuiListUser("",user.getShownNick());
			users.add(user);
			return;
		}
		//if no User is in List
		userList.addElement(user.getShownNick());
		users.add(user);
	}
}

