
package ParaIrc.client;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;

public class ParaIrcConfig {
	private String[] configname = new String[100];
	private String[] configvalue = new String[100];
	private int confcount=0;


	public ParaIrcConfig()
	{
		
	}
	public ParaIrcConfig(InputStream input)
	{
		loadConfigfromStream(new InputStreamReader (input));
	}
	
	public String getConfig(String confname)
	{
		for (int i=0;i<confcount;i++)
		{
			if (configname[i].equalsIgnoreCase(confname))
			{
				return configvalue[i];
			}
		}
		return "";
	}
	
	public int getConfigInt(String confname)
	{
		for (int i=0;i<confcount;i++)
		{
			if (configname[i].equalsIgnoreCase(confname))
			{
				try 
				{
					return Integer.parseInt(configvalue[i]);
				}
				catch (Exception e)
				{
					return 0;
				}
			}
		}
		return 0;
	}
	
	public void setConfig(String confname,String confvalue)
		{
			for (int i=0;i<confcount;i++)
			{
				if (configname[i].equalsIgnoreCase(confname))
				{
					configvalue[i]=confvalue;
					return;
				}
			}
			configname[confcount]=confname;
			configvalue[confcount]=confvalue;
			confcount++;		
		}
	
	public void loadConfigFromFile(String filename)
	{
		try {
			loadConfigfromStream(new FileReader(filename));
		} catch (FileNotFoundException e) {
			System.out.println("Error reading ConfigFile:"+filename);
			ParaIrc.loader.handleException(e);
		}
	}
	
	public void saveConfigToFile(String filename)
	{
		BufferedWriter newConfigFile;
		try 
		{
			newConfigFile =new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename)));
			for (int i=0;i<confcount;i++)
			{
				newConfigFile.write(configname[i]+"="+configvalue[i]+"\n");
			}
			newConfigFile.close();
		}
	 	catch (Exception e) 
	 	{
			ParaIrc.loader.handleException(e);
	 	}
	}
	
	protected void loadConfigfromStream(Reader input)
		{
			try
			{
				BufferedReader fr=new BufferedReader(input);
				String read="";
				while ((read=fr.readLine()) != null)
				{
					String text = read.toString();
					if(text.indexOf("=")>0&&text.indexOf("#")!=0)
					{
						setConfig(text.substring(0,text.indexOf("=")),text.substring(text.indexOf("=")+1));
					}
				}
				fr.close();
			}	
			catch(IOException e)
			{
				System.err.println("Error while reading config file");
				ParaIrc.loader.handleException(e);
			}
		}
}
