package ParaIrc.client;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

class ParaIrcGuiStatus extends JComponent
{
	private ParaIrcGuiColorPane textfield;
	private JTextField sendtext;
	
	public void printMessage(String message)
	{
		printMessage(message,Color.BLACK);
	}
	
	public void printMessage(String message,Color c)
	{
		JTabbedPane tab= ParaIrc.getGui().getTab();
		if (textfield!=null)
		{
			int currentPos = tab.indexOfTab(this.getName());
			if ( tab.getSelectedIndex()!= currentPos && currentPos>-1)
			{
				if ( ParaIrc.getConfigBool("displayImage") && tab.getIconAt(currentPos)==null)
				{
					tab.setIconAt( currentPos,ParaIrcGui.CHANGEICON);
				}
				if (ParaIrc.getConfigBool("changeColorOnChange") && tab.getTitleAt(currentPos)!=null && !tab.getTitleAt(currentPos).startsWith("<html><font color="+ParaIrc.getConfig("newMsgColorinHTML")+">"))
				{
					tab.setTitleAt(currentPos,("<html><font color="+ParaIrc.getConfig("newMsgColorinHTML")+">"+tab.getTitleAt(currentPos)));
				}			
			}
			textfield.append(c,message+"\n");
		}
		else
		{
			System.out.println(message); 
		}
	}
	
	public ParaIrcGuiStatus()
	{ 
		ActionListener sendclick = new ActionListener()
		{
			public void actionPerformed( ActionEvent e )
			{
				if (sendtext.getText().indexOf("/")==0)
				{
					ParaIrc.loader.processMessage( sendtext.getText(),""); 
					sendtext.setText("");
				}
			}
		};
		sendtext = new JTextField("",25);
		sendtext.addActionListener(sendclick);
		this.setLayout(new BorderLayout(1,2));
		textfield= new ParaIrcGuiColorPane();
		textfield.setFont(new Font(ParaIrc.getConfig("statusFont"), Font.LAYOUT_LEFT_TO_RIGHT, ParaIrc.getConfigInt("statusFontsize")));
		JScrollPane textScrollPane = new JScrollPane(textfield);
		//textScrollPane.add(textfield);
		textfield.setScrollBar(textScrollPane);
		this.add(textScrollPane,BorderLayout.CENTER);
		this.add(sendtext,BorderLayout.SOUTH);
		this.setVisible(true);
	
	}
	
	
	public String getName()
	{
		return ParaIrc.getConfig("statusText");	
	}
}

public class ParaIrcGui extends JFrame{
	
	public static Icon CHANGEICON= new ImageIcon(ParaIrc.class.getResource( "/ParaIrc/Resources/newMsg.png" ));
	private Button send;
	private ParaIrcLoader loader;
	private ParaIrcGuiStatus status;	
	private ParaIrcChannels channels;
	private JTabbedPane tab;
	private ParaIrcOptions optionsDlg;
	private JMenuItem optionsMenu;
	private JMenuItem aboutMenu;
	private ParaIrcAbout aboutDlg;
	private JMenuBar mbar;
	private JMenu serverMenu;
	private JMenu ParaIrcMenu;
	private JMenuItem serverConnect;
	private JMenuItem serverDisconnect;
	private JMenuItem changeNick;
	private JMenuItem joinChannel;
	private JMenuItem paraIrcExit;
	
	
	public ParaIrcGui()
	{
		
  		aboutDlg=new ParaIrcAbout();
		channels = new ParaIrcChannels(this,20);
		this.setIconImage(ParaIrc.getParaIrcIcon(this));
		this.setTitle(ParaIrc.AppTitle+" - not connected");
		// restore Position
		if ( ParaIrc.getConfig("GUILocation").length()>2)
		{
			String pos = ParaIrc.getConfig("GUILocation");
			int x=0;
			int y=0; 
			try
			{
				x = Integer.parseInt(pos.substring(0,pos.indexOf(",")));
				y = Integer.parseInt(pos.substring(pos.indexOf(",")+1));
			}
			catch (Exception e)
			{	
				//e.printStackTrace();
			}
			finally
			{
				setLocation(x,y);
			}
			
		}
		else
			this.setLocationRelativeTo(null);
		// restore Size
		if ( ParaIrc.getConfig("GUISize").length()>2)
		{
			String size = ParaIrc.getConfig("GUISize");
			int x=700;
			int y=450; 
			try
			{
				x = Integer.parseInt(size.substring(0,size.indexOf(",")));
				y = Integer.parseInt(size.substring(size.indexOf(",")+1));
			}
			catch (Exception e)
			{	
				//e.printStackTrace();
			}
			finally
			{
				setSize(x,y);
			}
			
		}
		else
			setSize(700,450);
		
		
		addWindowListener(new WindowAdapter() {
			  public void windowClosing(WindowEvent e) {
			  	ParaIrc.quitParaIrc();			  
			  }
			});
			
		// Options Dialog
		optionsDlg = new ParaIrcOptions();
			
		// MENU
		mbar = new JMenuBar();
		serverMenu= new JMenu("Server");
		ParaIrcMenu= new JMenu("ParaIrc");
		serverConnect=new JMenuItem("Connect");
		serverDisconnect=new JMenuItem("Disconnect");
		changeNick=new JMenuItem("change Nickname");
		joinChannel=new JMenuItem("join Channel");
		serverMenu.add(serverConnect);
		serverMenu.add(serverDisconnect);
		serverMenu.add(changeNick);
		serverMenu.add(joinChannel);
		optionsMenu= new JMenuItem( "Options" );
		aboutMenu = new JMenuItem("About") ;
		paraIrcExit = new JMenuItem("Quit");
		ParaIrcMenu.add(optionsMenu);
		ParaIrcMenu.add(aboutMenu);
		ParaIrcMenu.add(aboutMenu);
		ParaIrcMenu.add(paraIrcExit);
		ActionListener ServerClick = new ActionListener()
					   {
						public void actionPerformed(ActionEvent arg0) 
						{
							if (arg0.getSource().equals(serverConnect))
							{
								ParaIrc.getLoader().refreshIrcLib();
								ParaIrc.getLoader().ircLib.getIrc().connect();
							} 
							if (arg0.getSource().equals(serverDisconnect))
							{
								ParaIrc.getLoader().ircLib.getIrc().disconnect();					
							}
							if (arg0.getSource().equals(joinChannel))
							{
								(new ParaIrcCommandWindow("joinchannel")).setVisible(true);
							}
							if (arg0.getSource().equals(changeNick))
							{
								(new ParaIrcCommandWindow("changenick")).setVisible(true);
							}
							if (arg0.getSource().equals(aboutMenu))
							{
								aboutDlg.setVisible(true);	
							}
							if (arg0.getSource().equals(optionsMenu))
							{
								optionsDlg.setVisible(true);
							}
							if (arg0.getSource().equals(paraIrcExit))
							{
								ParaIrc.quitParaIrc();
							}
						}
					   };
		aboutMenu.addActionListener(ServerClick);
		optionsMenu.addActionListener(ServerClick);
		serverConnect.addActionListener(ServerClick);
		serverDisconnect.addActionListener(ServerClick);
		joinChannel.addActionListener(ServerClick);
		changeNick.addActionListener(ServerClick);
		paraIrcExit.addActionListener(ServerClick);
		mbar.add(ParaIrcMenu);
		mbar.add(serverMenu);
		//mbar.setLayout(new FlowLayout(FlowLayout.LEFT));
		this.setJMenuBar(mbar);
		
		//TABPANE
		ChangeListener tabChange = new ChangeListener()
				{
					public void stateChanged(ChangeEvent arg0) 
					{
						tab.setIconAt(tab.getSelectedIndex(),null);
						String htmlTag = "<html><font color="+ParaIrc.getConfig("newMsgColorinHTML")+">";
						if (tab.getTitleAt(tab.getSelectedIndex()).startsWith(htmlTag))
						{
							tab.setTitleAt(tab.getSelectedIndex(),tab.getTitleAt(tab.getSelectedIndex()).substring(htmlTag.length()));
						}

					}
				};
		tab= new JTabbedPane();
		tab.addChangeListener(tabChange);
		getContentPane().add(tab);
		status = new ParaIrcGuiStatus(); 
		tab.add(status);
		
	}
	
	public JTabbedPane getTab()
	{
		return tab;
	}
	
	public void setLoader(ParaIrcLoader loader)
	{
		this.loader=loader;
	}
	
	public ParaIrcGuiStatus getStatusField()
	{
		if (status!=null)
		{
			return status;
		}
		else
		{
			return new ParaIrcGuiStatus();
		}
	}
	
	public ParaIrcChannels getChannels()
	{
		return channels;
	}
	
	
	public void userJoin(String user, String channel) //If a User joins Channel
	{
		
	}
	
	public void userPart(String user, String channel) //If a User leaves Channel
	{
		
	}
	
	public void userQuit(String user, String quitMessage) //If a User Quits
	{
	 
	}
	
	public void userChangeNick(String oldNick, String newNick) //If a User changes Nick
	{
		
	}
	
	
	
	
	public String getVersion()
	{
		return ParaIrc.AppTitle;
	}

	/**
	 *  updates Name of Frame
	 */
	public void updateName(String title) {
		this.setTitle(ParaIrc.AppTitle+" - "+title);
		
	}

	public void savePosition() {
		ParaIrc.setConfig("GUILocation",(int)getLocation().getX()+","+(int)getLocation().getY());
		ParaIrc.setConfig("GUISize",(int)getSize().width+","+(int)getSize().height);
		
	}

	public ParaIrcOptions getOptionsDlg() {
		return optionsDlg;
	}


}

class ParaIrcGUIOptions extends Frame
{	
	public ParaIrcGUIOptions(final ParaIrcGui gui)
	{		
		addWindowListener(new WindowAdapter() {
			  public void windowClosing(WindowEvent e) {
			      setVisible(false);
			  }
		});
		setSize( 300, 200 );
		setVisible( true );
		setLayout(new FlowLayout(FlowLayout.CENTER, 10 ,5));
		add(new Label("Nickname :"));
		final TextField nicktext = new TextField("",25);
		add(nicktext);
		add(new Label("Server :"));
		final TextField servertext = new TextField("",25);
		add(servertext);
		add(new Label("Port :"));
		final TextField porttext = new TextField("",25);
		add(porttext);
		
		ActionListener connectClick = new ActionListener()
		{
				public void actionPerformed( ActionEvent e )
				{
					ParaIrc.setConfig("server",servertext.getText());
					ParaIrc.setConfig("port",porttext.getText());
					ParaIrc.setConfig("nickname",nicktext.getText());
					ParaIrc.setConfig("connectonce","1");
					setVisible(false);
					gui.setVisible(true);;			
				}				
		};	
		
		Button connButton = new Button("Connect");		
		connButton.addActionListener(connectClick);
		add(connButton);		
	}
	
}

