/*
 * Created on 21.03.2004
 */
package ParaIrc.client;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.Arrays;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.text.BadLocationException;

public class ParaIrcOptions extends JFrame {
	private ArrayList options= new ArrayList();
	private JButton optionsOK;
	private int rowCounter=0;
	
	
	private void addOption(ParaIrcOptionsInterface newOption)
	{
		if ( newOption instanceof OptionsCheck)
		{
			this.getContentPane().add((JComponent)newOption, new GridBagConstraints(0, rowCounter, 2, 1, 0.0, 0.0, GridBagConstraints.WEST, 1, new Insets(0, 0, 0, 0), 0, 0));
		}
		else
		{
			this.getContentPane().add(new JLabel(newOption.getCaption()), new GridBagConstraints(0, rowCounter, 1, 1, 0.0, 0.0, 13, 2, new Insets(0, 0, 0, 0), 0, 0));
			this.getContentPane().add((JComponent)newOption, new GridBagConstraints(1, rowCounter, 1, 1, 0.0, 0.0, 13, 2, new Insets(0, 0, 0, 0), 0, 0));
		}
		options.add(newOption);
		newOption.setText(ParaIrc.getConfig(newOption.getConfigName()));
		rowCounter++;
	}
	

	
	public void setVisible(boolean visible)
	{
		super.setVisible(visible);
		this.validate();
	}
	
	public ParaIrcOptions()
	{
		
				ActionListener okClick = new ActionListener()
				{
					public void actionPerformed(ActionEvent arg0) {
						for (int i=0;i<options.size();i++)
						{
							((ParaIrcOptionsInterface)options.get(i)).saveConfig();
						}
						setVisible(false);											
					}
				};	
		  		optionsOK= new JButton("Ok");
		  		optionsOK.addActionListener(okClick);
				
				GridBagLayout thisLayout = new GridBagLayout();
				JPanel panel = new JPanel();

				panel.setLayout(thisLayout);
				this.getContentPane().setLayout(thisLayout);
				
				addOption(new OptionsText("Nickname","NickName"));
				addOption(new OptionsText("Realname","Realname"));
				addOption(new OptionsText("Server","server"));
				addOption(new OptionsText("ServerPort","port"));
				addOption(new OptionsText("Quit-Message","QuitMessage"));
				addOption(new OptionsText("<html><table><tr><td>AutoConnect<br><font size=-2>(0=no 2000=every 30sec)<td>","autoconnect"));
				addOption(new OptionsCheck("Display Image on new Message","displayImage"));
				addOption(new OptionsCheck("change Channel-Color on new Message","changeColorOnChange"));
				addOption(new OptionsCheck("Display Nick/MemoServ in Status only","displayMCServInStatus"));
				addOption(new OptionsPerformList("Perform on Connect","Perform"));
				
				this.getContentPane().add(optionsOK, new GridBagConstraints(0, rowCounter, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, 0, new Insets(0, 0, 0, 0), 0, 0));
				
				thisLayout.columnWidths = new int[] {1,2};
				thisLayout.columnWeights = new double[] {0.01,0.1};
				thisLayout.rowHeights = new int[rowCounter+1];
				thisLayout.rowWeights = new double[rowCounter+1];
				Arrays.fill(thisLayout.rowHeights,1);
				Arrays.fill(thisLayout.rowWeights,0.1);

				// restore Size
				if ( ParaIrc.getConfig("OptionsSize").length()>2)
				{
					String size = ParaIrc.getConfig("OptionsSize");
					int x=420;
					int y=350; 
					try
					{
						x = Integer.parseInt(size.substring(0,size.indexOf(",")));
						y = Integer.parseInt(size.substring(size.indexOf(",")+1));
					}
					catch (Exception e)
					{	
						//e.printStackTrace();
					}
					finally
					{
						this.setSize(x,y);
					}
					
				}
				else
					this.setSize(420,350);
				
				// Set Icon and Title
				this.setIconImage(ParaIrc.getParaIrcIcon(this));
				this.setTitle("ParaIrc Options");
				this.setLocationRelativeTo(ParaIrc.getGui());
				
				addWindowListener(new WindowAdapter() 
				{
					  public void windowClosing(WindowEvent e) 
					  {
					  }
				});
	}
	
	public void saveSize() {
		//ParaIrc.setConfig("OptionsLocation",(int)getLocation().getX()+","+(int)getLocation().getY());
		ParaIrc.setConfig("OptionsSize",(int)getSize().width+","+(int)getSize().height);
		
	}
}

class OptionsText extends JTextField implements ParaIrcOptionsInterface
{
	private String labelName;
	private String configname;
	
	public OptionsText(String label, String configname)
	{
		labelName=label+" :";
		this.configname=configname;

	}

	public void saveConfig() 
	{
		ParaIrc.setConfig(configname,this.getText());	
		
	}


	public String getConfigName() {
		return configname;
	}

	public String getCaption() {
		return labelName;
	}
}

class OptionsPerformList extends JComponent implements ParaIrcOptionsInterface
{
	private JTextArea optionsList;
	private String labelName;
	private String configname;
	
	public OptionsPerformList (String label, String configname)
	{
		this.configname=configname;
		labelName=label+" :";
		optionsList=new JTextArea();
		this.setLayout(new GridLayout(1,1));
		this.add (new JScrollPane(optionsList));
		optionsList.setLineWrap(false);
	}
	
	public void saveConfig()
	{
		String tempText="";
		String tempConfig="";
		try 
		{
			tempText =optionsList.getDocument().getText(	0,	optionsList.getDocument().getLength());
		} 
		catch (BadLocationException e) 
		{
			ParaIrc.loader.handleException(e);
		}		
		
		while (tempText.indexOf("\n")>0)
		{
			tempConfig+=tempText.substring(0,tempText.indexOf("\n"))+"@";
			tempText=tempText.substring(tempText.indexOf("\n")+1);
		}
		tempConfig=tempConfig+tempText;
		ParaIrc.setConfig(configname,tempConfig);	
	}
	
	public void setText(String text)
	{
		while (text.indexOf("@")>0)
		{
			optionsList.append(text.substring(0,text.indexOf("@"))+"\n");
			text=text.substring(text.indexOf("@")+1);
		}
		if (!text.equals("")) {optionsList.append(text+"\n");} 
		
	}
	
	public String getConfigName() 
	{
		return configname;
	}

	public String getCaption() {
		return labelName;
	}
	
}


class OptionsCheck extends JComponent implements ParaIrcOptionsInterface
{
	private JLabel labelName;
	private JCheckBox configCheck;
	private String configname;
	
	public OptionsCheck(String label, String configname)
	{
		this.configname=configname;
		labelName=new JLabel(label+" : ");
		configCheck=new JCheckBox();
		this.setLayout(new BorderLayout());
		this.add (labelName,BorderLayout.CENTER);
		this.add (configCheck,BorderLayout.EAST);
	}
	
	public void saveConfig()
	{
		ParaIrc.setConfig(configname,(configCheck.isSelected()? "1" : "0"));	
	}
	
	public void setText(String text)
	{
		configCheck.setSelected(text.equals("1") );
	}
	
	public String getConfigName() 
	{
		return configname;
	}

	public String getCaption() {
		return labelName.getText();
	}
}
