package ParaIrc.irclib;


public class Irc extends Thread
{
	
	

	static IrcCore ircCore;
	public static IrcMain ircMain;
	private static Irc thisIrc; 
	static IrcInterface ircApplication; //Application which uses IRCLib
	//OPTIONS
	
	static int checkMessageInterval=15; //time in ms between checking SocketStream
	static int autoConnect=0; //Autoconnect 0=no x=reconnect in x*checkMessage ms  
	static String nick="IrcLib";
	static String server="irc.freenode.org";
	static String realname="ParaIrc";
	static int port=6667;
	static int connectOnce=0;
	static int ServerTimeout=30000;
	static int checkActiveConn=5;
	
	//Status 
	static boolean connected=false;
	static boolean allowShutdown=false;
	
	private final int DCCQueueSize=10;
	private waitingDCC[] waitingDCCArray=new waitingDCC[DCCQueueSize];
	
	public Irc(IrcInterface interfaceObject)
	{
		ircApplication = interfaceObject;
		thisIrc=this;
	}
	public static Irc getIrcStatic()
	{
		return thisIrc;
	}
		
	public Irc getIrc()
	{
		return thisIrc;
	}
	
	public void run()
	{
		ircCore= new IrcCore();
		Thread CoreThread = new Thread(ircCore);
		CoreThread.start();
	}
	
	public void connect()
	{

		ircMain.connect();
	}
	
	public void disconnect()
	{
		ircMain.disconnect();
	}
	
	public String getServerString()
	{
		return server+":"+port;
	}
	
	public String getNick()
	{
		return nick;
	}
	
	public void setNick(String nicks)
	{
		Irc.nick=nicks;
	}
	
	public void setPort(int port)
	{
		Irc.port=port;
	}
	
	public void setServerTimeout(int timeout)
	{
		Irc.ServerTimeout=timeout;
	}
	
	public void setcheckConn(int checkconn)
	{
		Irc.checkActiveConn=checkconn;
	}
	
	public void setServer(String server)
	{
		Irc.server=server;
	}
	
	public void setAutoConnect (int autoint)
	{
		Irc.autoConnect=autoint;
	}
	public void setCheckMessageInterval(int checkMessageInterval)
	{
		Irc.checkMessageInterval=checkMessageInterval;
	}
	
	static void sleepMs(int ms)
	{
		try
		{
			Thread.sleep(ms);			
		}
		catch (Exception e)
		{
			Irc.ircApplication.handleException(e);
		}
	}

	/**
	 * 
	 */
	public void shutdown() {
		ircMain.disconnect();
		allowShutdown=false;
		
	}
	
	public void processMessage(String message,String channel)
	{
		ircMain.processMessage(message,channel);
	}

	/**
	 * @param string
	 * @param filename
	 * @param ip
	 * @param port
	 * @param filesize
	 */
	public void addWaitingDCC(String sender,String command, String filename, String ip, int port, int filesize) {
		if (command.equals("SEND"))
		{
			int i=0;
			while (waitingDCCArray[i]!=null && i<DCCQueueSize)
			{
				i++;
			}
			if (waitingDCCArray[i]==null)
			{
				waitingDCCArray[i]=new waitingDCC(sender,command,filename,ip,port,filesize);
				ircApplication.askDCCRequest(i,sender,command,filename);
			}
		}
		
	}

	public void acceptDCCQueue(int i) {
		waitingDCCArray[i].start();
		
	}

	/**
	 * @param RealName
	 */
	public void setRealName(String rname) {
		if (rname!="")
		{		realname=rname; } 
		
	}
}