/*
 * Created on 21.12.2003
 */

package ParaIrc.irclib;

import java.util.*;
import java.text.*;


public class IrcChat extends Thread {

	private String eingabe;
	private IrcMain main;
	
	public IrcChat(IrcMain Irctemp)
	{
	main=Irctemp;
	}
	
	private void userJoin(String user,String channel) //If a User joins a Channel
	{
		Irc.ircApplication.userJoin(user,channel);
	}
	private void userPart(String user,String channel) //If a User leaves a Channel
	{
		if (! Irc.nick.equals(user)) 
		{
			Irc.ircApplication.userPart(channel,user);
			//main.getChannels().getChannel(channel).removeUser(user);
		} 
		
	}
	private void userNick(String oldNick,String newNick) //If a User changes Nick
	{
		if (oldNick.equals(main.getNick()))
		{
			main.setNick(newNick);
		}
		Irc.ircApplication.userNickChange(oldNick,newNick);	
		//ParaIrcOld.getChannels().userChangedNick(oldNick,newNick);
		//ParaIrc.printOut(":!:"+oldNick+" has changed Nick to "+newNick,ParaIrc.getColor("Nick"));
	}
	private void userQuit(String user,String message) //If a User quits
	{
		Irc.ircApplication.userQuit(user,message);
		//ParaIrcOld.getChannels().userQuit(user,message);
	}
	
	private void incomeMessage(String sender,String receiver,String text)
	{
		if (receiver.indexOf("#")==0)
		{
			Irc.ircApplication.channelMessage(receiver,sender,text);
		}
		else
		{
			Irc.ircApplication.userMessage(sender,text);	
		}
	}

	private void processPrivmsgCTCP(String message,String sender)
	{
		if (message.indexOf("VERSION")==1)
		{
			main.sendNotice("\u0001VERSION "+Irc.ircApplication.getVersion(sender)+"\u0001",sender);
		}
		else if (message.indexOf("PING")==1)
		{
			main.sendNotice(message,sender);	
		}else if (message.indexOf("TIME")==1)
		{
			SimpleDateFormat fmt = new SimpleDateFormat();
			fmt.applyPattern( "dd.MM.yyyy 'at' HH:mm:ss" );
			Calendar cal = new GregorianCalendar(TimeZone.getTimeZone("ECT"));
			main.sendText("\u0001TIME "+fmt.format(cal.getTime())+"\u0001",sender);
		}else if(message.indexOf("DCC")==1)
		{
			gotDCCMessage(message.substring(5),sender);
		}
	}

	/**
	 * Converts 32Bit-Hex-Value to IP-String
	 * @param 32bit-Hex-Value
	 */
	private String getIPfromInt(long ip)
	{
		StringBuffer sb = new StringBuffer(15);
		
		sb.append((ip >> 24) & 0xFF);
		sb.append(".");
		sb.append((ip >> 16) & 0xFF);
		sb.append(".");
		sb.append((ip >> 8) & 0xFF);
		sb.append(".");
		sb.append(ip & 0xFF);
		
		return sb.toString();
	}
	
	
	
	/**
	 * When User gets a DCC Message
	 * @param message
	 */
	private void gotDCCMessage(String message,String sender) {
		
		/* DON'T PROCESS DCC AT THE MOMENT - INCOMPLETE IMPLEMENTATION

		if (message.indexOf("SEND")==0)
		{
			message=message.substring(5);
			String filename=message.substring(0,message.indexOf(" "));
			message=message.substring(message.indexOf(" ")+1);
			String ip=getIPfromInt(Long.parseLong(message.substring(0,message.indexOf(" "))));
			message=message.substring(message.indexOf(" ")+1);
			int port=Integer.parseInt(message.substring(0,message.indexOf(" ")));
			message=message.substring(message.indexOf(" ")+1);
			int filesize=Integer.parseInt(message.substring(0,message.length()-1));
			Irc.getIrcStatic().addWaitingDCC(sender,"SEND",filename,ip,port,filesize);
		}
		*/
		
	}

	private void processNoticeCTCP(String message,String sender)
	{
		if(message.indexOf("PING")>-1)
		{
			long pingtime;
			message=message.substring(message.indexOf("PING")+5);
			pingtime=Long.parseLong(message.substring(0,13));
			pingtime=System.currentTimeMillis()-pingtime;
			message=" PING : "+pingtime+"ms"; 
			Irc.ircApplication.returnCTCP(sender+message);
		}
		else if(message.indexOf("VERSION")>-1)
		{
			Irc.ircApplication.returnCTCP(sender+message);
		}
		else if(message.indexOf("TIME")>-1)
		{
			Irc.ircApplication.returnCTCP(sender+message);
		}
		else
		{
			Irc.ircApplication.returnCTCP(sender+message);
		}
	}
	
	private String processCommand(String message,String sender)
	{
		String command=message.substring(0,message.indexOf(" "));
		message=message.substring(message.indexOf(" ")+1);
		
		if (command.equals("PRIVMSG"))
		{
						
			String receiver=message.substring(0,message.indexOf(" "));
			message=message.substring(message.indexOf(" ")+2);
			if(message.charAt(0)=='\u0001') // CTCP-Kommando
			{	
				processPrivmsgCTCP(message,sender);
			}	
			else
			{
				incomeMessage(sender,receiver,message);
			}						
		} else if (command.equals("JOIN"))
		{
			userJoin(sender,message.substring(message.indexOf(":")+1));
		} else if (command.equals("NICK"))
		{
			userNick(sender,message.substring(message.indexOf(":")+1));
		}else if (command.equals("QUIT"))
		{
			userQuit(sender,message.substring(message.indexOf(":")+1));
		}else if (command.equals("PART"))
		{						
			userPart(sender,message.substring(0,message.indexOf(" ")+1));			
		}else if(command.equals("NOTICE"))
		{
			message=message.substring(message.indexOf(":")+1);
			if(Character.getNumericValue(message.charAt(0))==-1) // CTCP-Kommando
			{	
				processNoticeCTCP(message,sender);
			}	
			else
			{
				incomeMessage(sender,"",message);
			}	
		}
		else if (command.equals("KICK"))
		{
			String channel=message.substring(0,message.indexOf(" "));
			message=message.substring(message.indexOf(" ")+1);
			String kickedUser=message.substring(0,message.indexOf(" "));
			userKicked(sender,channel,kickedUser,message.substring(message.indexOf(":")+1));		
		}
		else if (command.equals("MODE"))
		{		// Change MODE of USER 
			String channel=message.substring(0,message.indexOf(" "));
			message=message.substring(message.indexOf(" ")+1);
			String modes=message.substring(0,message.indexOf(" "));
			message=message.substring(message.indexOf(" ")+1);
			int counter=1;
			String nick="";
			while (message.indexOf(" ")>-1)
			{
				nick=message.substring(0,message.indexOf(" "));
				Irc.ircApplication.changeNickMode(modes.charAt(0),modes.charAt(counter),nick,channel,sender);
				counter++;
				message=message.substring(message.indexOf(" ")+1);
			}
			
		}
		else if (command.equals("TOPIC"))
		{		// Change TOPIC of CHannel 
			String channel=message.substring(0,message.indexOf(" "));
			message=message.substring(message.indexOf(" ")+1);
			String topic=message.substring(message.indexOf(":")+1);		
			Irc.ircApplication.changeTopic(sender,channel,topic);			
		}
		
		return "";
	}
	
	/**
	 * @param user
	 * @param channel
	 */
	private void userKicked(String user, String channel,String kickedUser,String reason) {
		Irc.ircApplication.userKicked(channel,user,kickedUser,reason);
		
	}

	private void processReplyCode(String errorcode,String text, String tempstr2)
	{
		String output="";
		if (errorcode.equals("1")) // WELCOME TO SERVER MESSAGE
		{
			
		}
		else if(errorcode.equals("332")) //Topic String
		{
			String channel=text.substring(0,text.indexOf(":")-1);
			text=text.substring(text.indexOf(":")+1);
			Irc.ircApplication.setTopic(channel,text);	
		}
		else if(errorcode.equals("333")) //Topic set by whom and when
		{
			String channel=text.substring(0,text.indexOf(" "));
			text=text.substring(text.indexOf(":")+1);
			Irc.ircApplication.setChannelInfo(channel,text);
		}		
		else if(errorcode.equals("353"))
		{
			String channel=text.substring(2,text.indexOf(":")-1);
			text=text.substring(text.indexOf(":")+1);
			Irc.ircApplication.addUsers(channel,text);		
		}
		else if(errorcode.equals("366")) //END OF NAMES List
		{
			// don't do anything
		}
		else if(errorcode.equals("376")) //END OF MOTD Message
		{
			Irc.ircApplication.serverWelcome();
		}
		else if (errorcode.equalsIgnoreCase("MODE"))
		{
			processCommand(errorcode+" "+tempstr2+" "+text,"Server");
		}
		else if (errorcode.equalsIgnoreCase("TOPIC"))
		{
			Irc.ircApplication.returnMessage("TOPIC:"+text);
		}
		else if (errorcode.equalsIgnoreCase("PONG"))
		{
			//Client got Response to a Server-Ping
		}
		else
		{
			output=text;
		}
		
		if (!output.equals(""))
		{
			Irc.ircApplication.serverMessage(errorcode,output);
		}
	}
	
	public void processIncome(String message)
	{
		String tempstr="";
		String result="";
		String sender="";
		if (message.indexOf("ERROR :Closing Link")>=0)
		{
		    Irc.ircMain.killSockets();
		}
		
		if(message.substring(0,4).equalsIgnoreCase("ping")) //Check for Ping-Event
		{			
			main.sendMessage("pong "+message.substring(5));
			Irc.ircApplication.returnMessage("Ping? Pong!");		
		}
		
		if(message.indexOf("@")>-1 && message.indexOf("@")<message.indexOf(" ")) 
		{	// normal Message
			sender=message.substring(1,message.indexOf("!"));
			tempstr=message.substring(message.indexOf(" ")+1);
			result=processCommand(tempstr,sender);
		}
		else if (message.indexOf(":")==0)//Message with Reply Code or /NAMES List
		{	
			tempstr=message.substring(message.indexOf(" ")+1);
			String errorcode=tempstr.substring(0,tempstr.indexOf(" "));
			String tempstr2 = tempstr.substring(0,tempstr.indexOf(" ")+1);
			tempstr = tempstr.substring(tempstr.indexOf(" ")+1);
			tempstr=tempstr.substring(tempstr.indexOf(" ")+1);
			processReplyCode(errorcode,tempstr,tempstr2);
		}
		else if(message.indexOf("NOTICE")==0)
		{
			Irc.ircApplication.returnMessage(message);
		}
		if (result!="")
		{
			Irc.ircApplication.returnMessage(result);
		}
	}
	
	
}
