package ParaIrc.irclib;


public interface IrcInterface
{
	public void ircReady(); //Main Parts are loaded
	public void ircConnected(); // connected to Server
	public void serverWelcome(); // Server has accepted User
	public void nickProblems(String message); //Nick in use or invalid
	public void serverMessage(String code,String message);
	public void userMessage(String user, String message);
	public void channelMessage(String channel, String message);
	public void channelMessage(String channel, String sender,String message);
	public void handleException(Exception e); //Throws Exception to Application
	public void returnMessage(String string); // print out normal Message
	public String getVersion(String user); // get Version String of Application
	public String getQuitMessage();  // get Quit message
	public void userPart(String channel, String user); //User leaves a channel
	public void userJoin(String channel, String user); //User joins a channel
	public void userQuit(String user, String message); //User quits a channel
	public void userNickChange(String oldNick, String newNick);
	public void addUsers(String channel, String text); // add Users from /Names command
	public void setChannelInfo(String channel, String text); // set Info of Channel
	public void setTopic(String channel, String text); //Set Channel Topic 
	/**
	 * @param c  + or -
	 * @param mode	 op,voice or whatevver
	 * @param nick name of nick
	 * @param channel which channel
	 */
	public void changeNickMode(char c, char mode, String nick,String channel,String setUser);
	/**
	 * @param String of CTCP Command
	 */
	public void returnCTCP(String text);
	/**
	 * When you get disconnected from Server
	 */
	public void disconnected();
	/**
	 * @param channel
	 * @param user
	 */
	public void userKicked(String channel, String user,String kickedUser,String reason);
	/**
	 * @param Number of Item in Queue
	 * @param sender
	 * @param command
	 * @param filename
	 */
	public void askDCCRequest(int i, String sender, String command, String filename);

	/**
	 * @param sender
	 * @param channel
	 * @param topic
	 */
	public void changeTopic(String sender, String channel, String topic); 
}