/*
 * Created on 21.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Martin SPler
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ParaIrc.irclib;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.Socket;


class IrcCheckConn extends Thread{
	
	private IrcMain main;
	private int counter=0;
	private int delay=1;
	
	
	public IrcCheckConn(IrcMain Irctemp,int delaytemp)
	{
		main=Irctemp;
		delay=delaytemp;
	}
	
	public void run ()
	{
		while(Irc.connected)
		try
		{
			Irc.sleepMs(delay*60*1000);
			main.sendMessage("PING "+counter);
			counter++;			
		}
		catch (Exception e)
		{
			Irc.ircApplication.handleException(e);
		}
	}
}

class IrcMain {
	
	protected BufferedReader ircInRead;
	protected BufferedWriter ircOutWrite;
	
	public InputStream ircIn;
	public OutputStream ircOut;
	
	private int counter=0;
	
	private BufferedReader buffread;
	private BufferedWriter buffwrite;
	
	private boolean autoconnect=true;
	private Socket socket;
	private String channel;
	private boolean connected=false;
	
	private IrcChat ircChat;
		
	public IrcMain()
	{
	}
	
	public IrcChat getIrcChat()
	{
		return ircChat;
	}

	boolean isConnected()
	{
		return Irc.connected;
	}
	
	void setServer(String server, int port)
	{
		Irc.ircApplication.returnMessage("Server changed to "+server+":"+port);
		Irc.server=server;
		Irc.port=port;	
	}
	
	int getCounter()
	{
		return counter;
	}
	
	boolean getConnectOnce()
	{
		if(Irc.connectOnce==1)
		{
			Irc.connectOnce=0;
			return true;
		}
		else
		{
			return false;
		}
	}
	
	void setCounter(int newCounter)
		{
			this.counter=newCounter;
		}
	
	void setNick(String nickstr)
	{
		Irc.nick=nickstr;
	}
	
	void changeNick(String nickstr)
	{
		sendMessage("nick "+nickstr);
		Irc.nick=nickstr;
		Irc.ircApplication.returnMessage("Nick changed to "+nickstr);
	}
	
	public String getNick()
	{
		return Irc.nick;
	}
	
	
	protected boolean connect()
	{	
		if (connected==true)
		{
			disconnect();
		}
		Irc.ircApplication.ircConnected();
		try
		{
			Irc.connected=true;
			Irc.ircApplication.returnMessage("Connecting to server ..."+Irc.server+":"+Irc.port);
			socket= new Socket(Irc.server,Irc.port);
			socket.setSoTimeout(Irc.ServerTimeout);
			
		}
		catch(Exception e)
		{
			
			Irc.ircApplication.returnMessage("Couldn't make connection ... ");
			return false;		
		}
	
		ircIn = null;
		ircOut = null;
	
		try
		{
			ircIn=socket.getInputStream();
			ircOut=socket.getOutputStream();
			Irc.connected=true;
		}
	
		catch (Exception e)
		{
			Irc.ircApplication.handleException(e);
			return false;
		}
		
		ircChat=new IrcChat(this);
		Thread ircThread = new Thread(ircChat);
		ircThread.start();
		ircInRead=new BufferedReader(new InputStreamReader(ircIn));
		ircOutWrite=new BufferedWriter(new OutputStreamWriter(ircOut));
		buffread = ircInRead;
		buffwrite = ircOutWrite;
				
		//Logon-Procedure
		if (Irc.realname.length()<2)
		{
			Irc.realname="NoRealLife";
		}
		sendMessage("user ParaIrc ware2 IRC :"+Irc.realname);
		sendMessage("nick "+Irc.nick);
	
//		Check PINGs
		if (Irc.checkActiveConn>0)
		{
 			Thread connectionThread = new Thread(new IrcCheckConn(this,Irc.checkActiveConn));
			connectionThread.start();
		}		
		return true;
	}
	

	public void disconnect()
	{
		if (Irc.connected)
		{	
			Irc.connected=false;
			Irc.connectOnce=0;
			Irc.ircApplication.disconnected();
			channel="";
			try 	
			{
				if (buffwrite!=null)
				{
					buffwrite.write("QUIT :"+Irc.ircApplication.getQuitMessage());
					buffwrite.newLine();
					buffwrite.flush();
					Irc.sleepMs(150);
				}
			}
			catch (Exception e)
			{
				Irc.ircApplication.handleException(e);
			}
			counter=0;	
		}
	}
	
	void killSockets()
	{
		try 
		{
            ircIn.close();
            ircOut.close();
    		socket.close();
        } 
		catch (IOException e) 
		{
            e.printStackTrace();
        }
		
	}
	
	public void sendText(String text,String receiver)
	{
		//DonkeyIrc.printOut(">"+receiver+"<:"+text);
		sendMessage("PRIVMSG "+receiver+" :"+text);
	}
	
	public void sendNotice(String text,String receiver)
		{
			//DonkeyIrc.printOut(">"+receiver+"<:"+text);
			sendMessage("NOTICE "+receiver+" :"+text);
		}
	
	public String getChannel()
	{
		return this.channel;
	}
	
	public boolean sendMessage(String message)
	{
		if (Irc.connected)
		try 	
		{
			buffwrite.write(message);
			buffwrite.newLine();
			buffwrite.flush();
		}
		catch (Exception e)
		{
		System.err.println("Error sending Message" + message);
		Irc.ircApplication.handleException(e);	
		disconnect();
		}
		
		return true;
	}
	
	public void joinChannel(String channel)
	{
		sendMessage("JOIN "+channel);
		Irc.ircApplication.returnMessage("joining Channel : "+channel);
	}
	
	public void leaveChannel(String channel)
	{
		sendMessage("PART "+channel);
	}
	
	public void processMessage(String message)
	{
		processMessage(message,"");
	}
	
	
	public void processMessage(String message, String channel)
	{
		if (message.indexOf("/")==0)
		{
			if (message.indexOf(" ")==-1)
			{
				message=message+" ";
			}
			String command=message.substring(1,message.indexOf(" "));		
			
			if (command.equals("join"))
			{	
				joinChannel(message.substring(message.indexOf(" ")+1));			
			}
			else if (command.equals("part"))
			{	
				leaveChannel(message.substring(message.indexOf(" ")+1));			
			}
			else if (command.equals("connect"))
			{	
				String tempstr=message.substring(message.indexOf(" ")+1);
				disconnect();
				if(message.indexOf(" ")>0&&message.indexOf(":")>0)
				{
					setServer(tempstr.substring(0,tempstr.indexOf(":")),Integer.parseInt(tempstr.substring(tempstr.indexOf(":")+1)));
				}		
				connect();			
			}
			else if(command.equals("disconnect"))
			{
				Irc.autoConnect=0;
				disconnect();
			}
			else if(command.equals("nick"))
			{
				changeNick(message.substring(message.indexOf(" ")+1));	
			}
			else if (command.equals("ping"))
			{	
				sendText("\u0001PING "+System.currentTimeMillis()+"\u0001",message.substring(5));			
			}
			else if (command.equals("version"))
			{	
				sendText("\u0001VERSION\u0001",message.substring(8));			
			}else if (command.equals("time"))
			{	
				sendText("\u0001TIME\u0001",message.substring(5));			
			}
			else if(command.equals("msg"))
			{
			String tempstr=message.substring(message.indexOf(" ")+1);
			// check that the text to send is not empty
			if (tempstr.indexOf(" ")>0 && tempstr.indexOf(" ")+1<tempstr.length())
				sendText(tempstr.substring(tempstr.indexOf(" ")+1),tempstr.substring(0,tempstr.indexOf(" ")));
			}
			else
			{
				sendMessage(message.substring(1));
			}
		}
		else
		{
		Irc.ircApplication.channelMessage(channel,Irc.nick,  message);
		sendText(message,channel);	
		}
	}
	
	public String getMessage()
	{	
		String message="";
		try
		{
			if(ircInRead.ready()) //if there's any traffic
			{
			message=ircInRead.readLine();
			}
		}
		catch (Exception e)
		{
			Irc.ircApplication.handleException(e);
		}
		return message;
	}
}